#!/usr/bin/perl -w

use LWP;
use Getopt::Std;

# WHAT THIS SCRIPT DOES:
# obtain list of university home URLs from webometrics.info

%opts = ();

getopts('u:',\%opts);

$womstarturl = "http://www.webometrics.info/en/North_america?page=0";

for (split /\n/, do_GET($womstarturl)) {
  if (/<a title="Go to last page" href="\/en\/North_america\?page=([0-9]+)"/) {
    $lastpage = $1;
  }
}



SCRAPE_NA: for ($counter = 0; $counter < $lastpage;) {
  
  $womurl = "http://www.webometrics.info/en/North_america?page=$counter";
  $wompage = do_GET($womurl);
  
  for (split /\n/, $wompage) {
   chomp;
   
   if (/tbody/) {
     $intable = 1;
   }
   
   elsif ($intable && /<tr class="(odd|even)"><td><center>[0-9]+<\/center><\/td><td><center>([0-9]+)<\/center><\/td><td><a href="(http:[^"]+)" target="_blank">([^\/<]+).*\/files\/logos\/(..)\.png"/) {
      $rank = $2;
      $home = $3;
      $name = $4;
      $country = $5;
      $name =~ s/[ ]$//;
      $name =~ s/\([^\)]+\) ?//gi;
      $name =~ s/&#039;/'/gi;
      $name =~ s/&amp;/and/gi;
      $name =~ s/[ ]/_/gi;
      print "$home $name $rank $country\n";
    }
   
   elsif ($intable && /<li class="pager-next">/) {
     $intable = 0;
     $counter++;
     sleep(2);
     redo SCRAPE_NA;
   }
 }
}

$womstarturl1 = "http://www.webometrics.info/en/Latin_america?page=0";

for (split /\n/, do_GET($womstarturl)) {
  if (/<a title="Go to last page" href="\/en\/Latin_america\?page=([0-9]+)"/) {
    $lastpage = $1;
  }
}



SCRAPE_LA: for ($counter = 0; $counter < $lastpage;) {
  
  $womurl = "http://www.webometrics.info/en/Latin_america?page=$counter";
  $wompage = do_GET($womurl);
  
  for (split /\n/, $wompage) {
   chomp;
   
   if (/tbody/) {
     $intable = 1;
   }
   
   elsif ($intable && /<tr class="(odd|even)"><td><center>[0-9]+<\/center><\/td><td><center>([0-9]+)<\/center><\/td><td><a href="(http:[^"]+)" target="_blank">([^\/<]+).*\/files\/logos\/(..)\.png"/) {
      $rank = $2;
      $home = $3;
      $name = $4;
      $country = $5;
      $name =~ s/[ ]$//;
      $name =~ s/\([^\)]+\) ?//gi;
      $name =~ s/&#039;/'/gi;
      $name =~ s/&amp;/and/gi;
      $name =~ s/[ ]/_/gi;
      print "$home $name $rank $country\n";
    }
   
   elsif ($intable && /<li class="pager-next">/) {
     $intable = 0;
     $counter++;
     sleep(2);
     redo SCRAPE_LA;
   }
 }
}

$womstarturl2 = "http://www.webometrics.info/en/Asia?page=0";

for (split /\n/, do_GET($womstarturl)) {
  if (/<a title="Go to last page" href="\/en\/Asia\?page=([0-9]+)"/) {
    $lastpage = $1;
  }
}



SCRAPE_A: for ($counter = 0; $counter < $lastpage;) {
  
  $womurl = "http://www.webometrics.info/en/Asia?page=$counter";
  $wompage = do_GET($womurl);
  
  for (split /\n/, $wompage) {
   chomp;
   
   if (/tbody/) {
     $intable = 1;
   }
   
   elsif ($intable && /<tr class="(odd|even)"><td><center>[0-9]+<\/center><\/td><td><center>([0-9]+)<\/center><\/td><td><a href="(http:[^"]+)" target="_blank">([^\/<]+).*\/files\/logos\/(..)\.png"/) {
      $rank = $2;
      $home = $3;
      $name = $4;
      $country = $5;
      $name =~ s/[ ]$//;
      $name =~ s/\([^\)]+\) ?//gi;
      $name =~ s/&#039;/'/gi;
      $name =~ s/&amp;/and/gi;
      $name =~ s/[ ]/_/gi;
      print "$home $name $rank $country\n";
    }
   
   elsif ($intable && /<li class="pager-next">/) {
     $intable = 0;
     $counter++;
     sleep(2);
     redo SCRAPE_A;
   }
 }
}

$womstarturl3 = "http://www.webometrics.info/en/Africa?page=0";

for (split /\n/, do_GET($womstarturl)) {
  if (/<a title="Go to last page" href="\/en\/Africa\?page=([0-9]+)"/) {
    $lastpage = $1;
  }
}



SCRAPE_AFRICA: for ($counter = 0; $counter < $lastpage;) {
  
  $womurl = "http://www.webometrics.info/en/Africa?page=$counter";
  $wompage = do_GET($womurl);
  
  for (split /\n/, $wompage) {
   chomp;
   
   if (/tbody/) {
     $intable = 1;
   }
   
   elsif ($intable && /<tr class="(odd|even)"><td><center>[0-9]+<\/center><\/td><td><center>([0-9]+)<\/center><\/td><td><a href="(http:[^"]+)" target="_blank">([^\/<]+).*\/files\/logos\/(..)\.png"/) {
      $rank = $2;
      $home = $3;
      $name = $4;
      $country = $5;
      $name =~ s/[ ]$//;
      $name =~ s/\([^\)]+\) ?//gi;
      $name =~ s/&#039;/'/gi;
      $name =~ s/&amp;/and/gi;
      $name =~ s/[ ]/_/gi;
      print "$home $name $rank $country\n";
    }
   
   elsif ($intable && /<li class="pager-next">/) {
     $intable = 0;
     $counter++;
     sleep(2);
     redo SCRAPE_AFRICA;
   }
 }
}

$womstarturl4 = "http://www.webometrics.info/en/aw?page=0";

for (split /\n/, do_GET($womstarturl)) {
  if (/<a title="Go to last page" href="\/en\/aw\?page=([0-9]+)"/) {
    $lastpage = $1;
  }
}



SCRAPE_AW: for ($counter = 0; $counter < $lastpage;) {
  
  $womurl = "http://www.webometrics.info/en/aw?page=$counter";
  $wompage = do_GET($womurl);
  
  for (split /\n/, $wompage) {
   chomp;
   
   if (/tbody/) {
     $intable = 1;
   }
   
   elsif ($intable && /<tr class="(odd|even)"><td><center>[0-9]+<\/center><\/td><td><center>([0-9]+)<\/center><\/td><td><a href="(http:[^"]+)" target="_blank">([^\/<]+).*\/files\/logos\/(..)\.png"/) {
      $rank = $2;
      $home = $3;
      $name = $4;
      $country = $5;
      $name =~ s/[ ]$//;
      $name =~ s/\([^\)]+\) ?//gi;
      $name =~ s/&#039;/'/gi;
      $name =~ s/&amp;/and/gi;
      $name =~ s/[ ]/_/gi;
      print "$home $name $rank $country\n";
    }
   
   elsif ($intable && /<li class="pager-next">/) {
     $intable = 0;
     $counter++;
     sleep(2);
     redo SCRAPE_AW;
   }
 }
}

$womstarturl4 = "http://www.webometrics.info/en/Oceania?page=0";

for (split /\n/, do_GET($womstarturl)) {
  if (/<a title="Go to last page" href="\/en\/Oceania\?page=([0-9]+)"/) {
    $lastpage = $1;
  }
}



SCRAPE_O: for ($counter = 0; $counter < $lastpage;) {
  
  $womurl = "http://www.webometrics.info/en/Oceania?page=$counter";
  $wompage = do_GET($womurl);
  
  for (split /\n/, $wompage) {
   chomp;
   
   if (/tbody/) {
     $intable = 1;
   }
   
   elsif ($intable && /<tr class="(odd|even)"><td><center>[0-9]+<\/center><\/td><td><center>([0-9]+)<\/center><\/td><td><a href="(http:[^"]+)" target="_blank">([^\/<]+).*\/files\/logos\/(..)\.png"/) {
      $rank = $2;
      $home = $3;
      $name = $4;
      $country = $5;
      $name =~ s/[ ]$//;
      $name =~ s/\([^\)]+\) ?//gi;
      $name =~ s/&#039;/'/gi;
      $name =~ s/&amp;/and/gi;
      $name =~ s/[ ]/_/gi;
      print "$home $name $rank $country\n";
    }
   
   elsif ($intable && /<li class="pager-next">/) {
     $intable = 0;
     $counter++;
     sleep(2);
     redo SCRAPE_O;
   }
 }
}



# Marco Baroni's sub to fetch html from urls

sub do_GET {
    # this is taken from the perl & lwp book (but I changed it a bit)

    $browser = LWP::UserAgent->new() unless $browser;
    $browser->timeout(10);
    $browser->env_proxy();
    
    my $response;

    # I've put the following in an eval block to try to survive
    # failed ntlm authentications... let's hope it doesn't
    # cause other kinds of trouble...

    eval {$response = $browser->get(@_);};

    if ($@) {
	print STDERR "something went wrong: $@\n";
	return;
    }
    
    return unless $response->is_success;

    return $response->content;
}

